
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ezkjdict.h"

static int _ezkj_find_delim(void);

static int _ezkj_find_delim(void)
{
  char ch;

  while ((ch = (char)getc(stdin)) != EOF)
  {
    if (ch == '|')
    {
      return 1;
    }
  }

  return 0;
}

int main(int argc, char **argv)
{
  ezkj_dict_t kjdictbuf;
  char ch;
  char utfstrbuf[128];
  int i;
  int unilen;
  WCHAR *unistrbuf;

  while (_ezkj_find_delim())
  {
    memset(&kjdictbuf, 0, sizeof(ezkj_dict_t));

    kjdictbuf.hidden = (char)getc(stdin) - '0';

    getc(stdin);

    for (i = 0; i < sizeof(utfstrbuf); i++)
    {
       utfstrbuf[i] = (char)getc(stdin);
       if (utfstrbuf[i] == '|')
       {
         utfstrbuf[i] = '\0';
         break;
       }
    }
    unilen = MultiByteToWideChar(65001, 0, utfstrbuf, -1, 0, 0);
    unistrbuf = malloc(unilen << 1);
    MultiByteToWideChar(65001, 0, utfstrbuf, -1, unistrbuf, unilen);
    WideCharToMultiByte(949, 0, unistrbuf, -1, kjdictbuf.krword_euckr,
      sizeof(kjdictbuf.krword_euckr), 0, 0);
    kjdictbuf.krword_euckr[sizeof(kjdictbuf.krword_euckr) - 1] = '\0';
    free(unistrbuf);

    for (i = 0; i < sizeof(utfstrbuf); i++)
    {
       utfstrbuf[i] = (char)getc(stdin);
       if (utfstrbuf[i] == '|')
       {
         utfstrbuf[i] = '\0';
         break;
       }
    }
    unilen = MultiByteToWideChar(65001, 0, utfstrbuf, -1, 0, 0);
    unistrbuf = malloc(unilen << 1);
    MultiByteToWideChar(65001, 0, utfstrbuf, -1, unistrbuf, unilen);
    WideCharToMultiByte(932, 0, unistrbuf, -1, kjdictbuf.jpword_sjis,
      sizeof(kjdictbuf.jpword_sjis), 0, 0);
    kjdictbuf.jpword_sjis[sizeof(kjdictbuf.jpword_sjis) - 1] = '\0';
    free(unistrbuf);

    for (i = 0; i < sizeof(kjdictbuf.part_of_speech); i++)
    {
       kjdictbuf.part_of_speech[i] = (char)getc(stdin);
       if (kjdictbuf.part_of_speech[i] == '|')
       {
         kjdictbuf.part_of_speech[i] = '\0';
         break;
       }
    }

    for (i = 0; i < sizeof(kjdictbuf.attributes); i++)
    {
       kjdictbuf.attributes[i] = (char)getc(stdin);
       if (kjdictbuf.attributes[i] == '|')
       {
         kjdictbuf.attributes[i] = '\0';
         break;
       }
    }

    fwrite(&kjdictbuf, sizeof(ezkj_dict_t), 1,stdout);
  }

  fflush(NULL);

  return 0;
}
